require 'omniauth-oauth2'

require 'openssl'

OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE

module OmniAuth
  module Strategies
    class Cloudron < OmniAuth::Strategies::OAuth2
      # Give your strategy a name.
      option :name, "cloudron"

      # This is where you pass the options you would pass when
      # initializing your consumer from the OAuth gem.
      option :client_options, {
        :site => ENV['OAUTH_ORIGIN'],
        :authorize_url => "#{ENV['OAUTH_ORIGIN']}/api/v1/oauth/dialog/authorize",
        :token_url => "#{ENV['OAUTH_ORIGIN']}/api/v1/oauth/token"
      }
      option :client_id, ENV['OAUTH_CLIENT_ID']
      option :client_secret, ENV['OAUTH_CLIENT_SECRET']
      option :provider_ignores_state, true

      # These are called after authentication has succeeded. If
      # possible, you should try to set the UID without making
      # additional calls (if the user id is returned with the token
      # or as a URI parameter). This may not be possible with all
      # providers.
      uid{ raw_info['id'] }

      info do
        {
          :name => raw_info['username'],
          :email => raw_info['email']
        }
      end

      extra do
        {
          'raw_info' => raw_info
        }
      end

      def raw_info
        # @raw_info ||= access_token.get('/api/v1/profile').parsed
        info = access_token.get('/api/v1/profile').parsed
        puts info
        return info
      end
    end
  end
end

OmniAuth.config.add_camelization 'cloudron', 'Cloudron'
